LeetCode 907. 子数组的最小值之和(单调栈)

题意:

给定一个整数数组 arr,找到 min(b) 的总和,其中 b 的范围为 arr 的每个(连续)子数组。

由于答案可能很大,因此 返回答案模 10^9 + 7 。

数据范围:
1 <= arr.length <= 3 * 104
1 <= arr[i] <= 3 * 104

解法:

利用单调递增栈计算出每个a[i]能够作为最小值能扩展的最大区间[l,r],
那么包含a[i]的子区间数量cnt=(i-l+1)*(r-i+1),
对答案的贡献就是cnt*a[i].

code:

class Solution {
public:
    static const int maxm=3e4+5;
    static const int mod=1e9+7;
    int l[maxm],r[maxm];
    int stk[maxm],h;
    int sumSubarrayMins(vector<int>& a) {
        int n=a.size();
        a.insert(a.begin(),(int)-1e9);
        a.push_back((int)-1e9);
        h=0;
        for(int i=1;i<=n+1;i++){
            while(h&&a[stk[h]]>a[i]){//这里是>
                r[stk[h--]]=i-1;
            }
            stk[++h]=i;
        }
        h=0;
        for(int i=n;i>=0;i--){
            while(h&&a[stk[h]]>=a[i]){//这里是>=
                l[stk[h--]]=i+1;
            }
            stk[++h]=i;
        }
        int ans=0;
        for(int i=1;i<=n;i++){
            int lc=i-l[i]+1;
            int rc=r[i]-i+1;
            int cnt=1ll*lc*rc%mod;
            ans=(ans+1ll*cnt*a[i]%mod)%mod;
        }
        return ans;
    }
};

上一篇:省选测试20


下一篇:剑指 Offer 09. 用两个栈实现队列 &Python stack & C++ stack